import { defineComponent as M, ref as v, onMounted as j, markRaw as L, watch as x, unref as w, openBlock as b, createElementBlock as S, computed as T, nextTick as Z, shallowRef as q, getCurrentInstance as K, onBeforeUnmount as Q, normalizeClass as X, normalizeStyle as Y, createBlock as ee, resolveDynamicComponent as te, mergeProps as ne } from "vue";
import "codemirror/lib/codemirror.css";
import H from "codemirror";
import "codemirror/addon/merge/merge.css";
import "codemirror/addon/merge/merge.js";
import oe from "diff-match-patch";
import "codemirror/addon/mode/simple.js";
!window.CodeMirror && (window.CodeMirror = H);
const _ = window.CodeMirror || H, re = M({
  name: "DefaultMode",
  props: {
    name: {
      type: String,
      default: `cm-textarea-${+/* @__PURE__ */ new Date()}`
    },
    value: {
      type: String,
      default: ""
    },
    content: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => null
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: {
    ready: (e) => e,
    "update:cminstance": (e) => e
  },
  setup(e, { emit: n }) {
    const r = v(), t = v(null), o = () => {
      t.value = L(_.fromTextArea(r.value, e.options)), n("update:cminstance", t.value);
      const a = x(
        () => e.cminstance,
        (l) => {
          var m;
          l && ((m = e.cminstance) == null || m.setValue(e.value || e.content)), n("ready", w(t)), a == null || a();
        },
        { deep: !0 }
      );
    };
    return j(() => {
      o();
    }), {
      textarea: r,
      initialize: o
    };
  }
}), I = (e, n) => {
  const r = e.__vccOpts || e;
  for (const [t, o] of n)
    r[t] = o;
  return r;
}, ae = ["name", "placeholder"];
function se(e, n, r, t, o, a) {
  return b(), S("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, ae);
}
const V = /* @__PURE__ */ I(re, [["render", se]]);
window.diff_match_patch = oe;
window.DIFF_DELETE = -1;
window.DIFF_INSERT = 1;
window.DIFF_EQUAL = 0;
const le = M({
  name: "MergeMode",
  props: {
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: n }) {
    const r = v(), t = v(), o = () => {
      r.value = L(
        _.MergeView(t.value, e.options)
      ), n("update:cminstance", r.value), n("ready", r);
    };
    return j(() => {
      o();
    }), {
      mergeView: t,
      initialize: o
    };
  }
}), ce = { ref: "mergeView" };
function ie(e, n, r, t, o, a) {
  return b(), S("div", ce, null, 512);
}
const ue = /* @__PURE__ */ I(le, [["render", ie]]);
var de = /* @__PURE__ */ ((e) => (e.info = "info", e.warning = "warning", e.error = "error", e))(de || {});
function pe() {
  const e = /* @__PURE__ */ new Date(), n = e.getHours() < 10 ? `0${e.getHours()}` : e.getHours(), r = e.getMinutes() < 10 ? `0${e.getMinutes()}` : e.getMinutes(), t = e.getSeconds() < 10 ? `0${e.getSeconds()}` : e.getSeconds();
  return `${n}:${r}:${t}`;
}
function Te(e) {
  return `#link#${JSON.stringify(e)}#link#`;
}
function me(e) {
  const n = /#link#(.+)#link#/g, r = [];
  let t;
  for (t = n.exec(e); t; ) {
    const o = document.createElement("a"), a = JSON.parse(t[1]), l = Object.entries(a);
    for (const [m, u] of l)
      o.setAttribute(m, u);
    o.className = "editor_custom_link", o.innerHTML = "logDownload", r.push({
      start: t.index,
      end: t.index + t[0].length,
      node: o
    }), t = n.exec(e);
  }
  return r;
}
function Ie(e = "", n = "info") {
  return `#log<${n}>log#${e}#log<${n}>log#`;
}
function ge(e) {
  const n = [];
  function r() {
    const t = /#log<(\w*)>log#((.|\r\n|\n)*?)#log<(\w*)>log#/g;
    let o;
    for (o = t.exec(e); o; ) {
      const l = o[0].replace(/\r\n/g, `
`).split(`
`), u = o[2].replace(/\r\n/g, `
`).split(`
`), d = document.createElement("span"), i = o[1];
      d.className = `c-editor--log__${i}`;
      let p = 0;
      for (let c = 0; c < l.length; c++) {
        const f = l[c], k = u[c], y = d.cloneNode(!1);
        y.innerText = k, n.push({
          start: o.index + p,
          end: o.index + p + f.length,
          node: y
        }), p = p + f.length + 1;
      }
      o = t.exec(e);
    }
  }
  return r(), n;
}
function De(e, n) {
  return `[${pe()}] <${n}> ${e}`;
}
function Ne(e, n, r) {
  const o = new Array(Math.max(n || 15, 5)).join(r || "=");
  return `${o}${e}${o}`;
}
const C = [
  {
    regex: /(\[.*?\])([ \t]*)(<error>[ \t])(.+)/,
    token: ["tag", "", "error.strong", "error.strong"],
    sol: !0
    // next: "error",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<info>)(.+)(.?)/,
    token: ["tag", "", "bracket", "bracket", "hr"],
    sol: !0
    // next: "info",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<warning>)(.+)(.?)/,
    token: ["tag", "", "comment", "comment", "hr"],
    sol: !0
    // next: "warning",
  }
];
_.defineSimpleMode("fclog", {
  start: [
    ...C,
    {
      regex: /.*/,
      token: "hr"
    }
  ],
  error: [
    ...C,
    {
      regex: /.*/,
      token: "error.strong"
    }
  ],
  info: [
    ...C,
    {
      regex: /.*/,
      token: "bracket"
    }
  ],
  warning: [
    ...C,
    {
      regex: /.*\[/,
      token: "comment"
    }
  ]
});
_.defineSimpleMode("log", {
  start: [
    {
      regex: /^[=]+[^=]*[=]+/,
      token: "strong"
    },
    {
      regex: /([^\w])([A-Z][\w]*)/,
      token: ["", "string"]
    },
    {
      regex: /(^[A-Z][\w]*)/,
      token: "string"
    }
    // {
    //     regex: /([^\d])([0-9]+)/,
    //     token: [null, 'comment']
    // },
    // {
    //     regex: /(^[0-9]+)/,
    //     token: 'comment'
    // }
  ]
});
const fe = M({
  name: "CodemirrorFclog",
  props: {
    value: {
      type: String,
      default: ""
    },
    name: {
      type: String,
      default: `cm-textarea-${+/* @__PURE__ */ new Date()}`
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: n }) {
    const r = v(), t = v(null), o = (l = e.cminstance) => {
      l.getAllMarks().forEach((i) => i.clear());
      const u = l.getValue(), d = [].concat(me(u)).concat(ge(u));
      for (let i = 0; i < d.length; i++) {
        const p = d[i];
        l.markText(
          l.posFromIndex(p.start),
          l.posFromIndex(p.end),
          { replacedWith: p.node }
        );
      }
    }, a = () => {
      var l;
      t.value = L(_.fromTextArea(r.value, e.options)), n("update:cminstance", w(t)), (l = t.value) == null || l.on("change", o);
    };
    return x(
      () => e.cminstance,
      (l) => {
        var m;
        l && (o(e.cminstance), (m = e.cminstance) == null || m.setValue(e.value), n("ready", t));
      },
      { deep: !0, immediate: !0 }
    ), j(() => {
      a();
    }), {
      initialize: a,
      textarea: r
    };
  }
}), he = ["name", "placeholder"];
function ve(e, n, r, t, o, a) {
  return b(), S("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, he);
}
const ye = /* @__PURE__ */ I(fe, [["render", ve]]), R = {
  "update:value": () => !0,
  change: (e, n) => ({ value: e, cm: n }),
  input: () => !0,
  ready: (e) => e
}, we = [
  "changes",
  "scroll",
  "beforeChange",
  "cursorActivity",
  "keyHandled",
  "inputRead",
  "electricInput",
  "beforeSelectionChange",
  "viewportChange",
  "swapDoc",
  "gutterClick",
  "gutterContextMenu",
  "focus",
  "blur",
  "refresh",
  "optionChange",
  "scrollCursorIntoView",
  "update"
], ke = () => {
  const e = {};
  return we.forEach((n) => {
    e[n] = (...r) => r;
  }), e;
}, $e = { ...R, ...ke() }, O = {
  mode: "text",
  // Language mode
  theme: "default",
  // Theme
  lineNumbers: !0,
  // Display line number
  smartIndent: !0,
  // Intelligent indentation
  indentUnit: 2
};
function xe(e) {
  Promise.resolve().then(() => {
    const n = e.getScrollInfo();
    e.scrollTo(n.left, n.height);
  });
}
const _e = ({
  props: e,
  cminstance: n,
  emit: r,
  internalInstance: t,
  content: o
}) => {
  const a = T(
    () => {
      var u;
      return e.merge ? (u = w(n)) == null ? void 0 : u.editor() : w(n);
    }
  ), l = () => {
    const u = [];
    return Object.keys(t == null ? void 0 : t.vnode.props).forEach((d) => {
      if (d.startsWith("on")) {
        const i = d.replace(d[2], d[2].toLowerCase()).slice(2);
        !R[i] && u.push(i);
      }
    }), u;
  };
  return {
    listenerEvents: () => {
      a.value.on("change", (i) => {
        const p = i.getValue();
        p === o.value && p !== "" || (o.value = p, r("update:value", o.value || ""), r("input", o.value || " "), Promise.resolve().then(() => {
          r("change", o.value, i);
        }), e.keepCursorInEnd && xe(i));
      });
      const u = {};
      l().filter((i) => !u[i] && (u[i] = !0)).forEach((i) => {
        a.value.on(i, (...p) => {
          r(i, ...p);
        });
      });
    }
  };
};
function be({ props: e, cminstance: n, presetRef: r }) {
  const t = v(null), o = v(null), a = T(
    () => {
      var c;
      return e.merge ? (c = w(n)) == null ? void 0 : c.editor() : w(n);
    }
  ), l = () => {
    Z(() => {
      var c;
      (c = a.value) == null || c.refresh();
    });
  }, m = (c = e.width, f = e.height) => {
    var y;
    t.value = String(c).replace("px", ""), o.value = String(f).replace("px", "");
    const k = o.value;
    (y = a.value) == null || y.setSize(t.value, k);
  }, u = () => {
    var f;
    const c = (f = a.value) == null ? void 0 : f.getWrapperElement();
    c == null || c.remove();
  }, d = () => {
    var f, k, y;
    const c = (f = a.value) == null ? void 0 : f.getDoc().getHistory();
    (k = r.value) == null || k.initialize(), u(), (y = a.value) == null || y.getDoc().setHistory(c);
  }, i = () => {
    const c = document.querySelector(".CodeMirror-gutters");
    return (c == null ? void 0 : c.style.left.replace("px", "")) !== "0";
  };
  return {
    reload: d,
    refresh: l,
    resize: m,
    destroy: u,
    containerHeight: o,
    reviseStyle: () => {
      if (l(), !i())
        return;
      const c = setInterval(() => {
        i() ? l() : clearInterval(c);
      }, 60), f = setTimeout(() => {
        clearInterval(c), clearTimeout(f);
      }, 400);
    }
  };
}
const F = /* @__PURE__ */ M({
  __name: "index",
  props: {
    value: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => O
    },
    globalOptions: {
      type: Object,
      default: () => O
    },
    placeholder: {
      type: String,
      default: ""
    },
    border: {
      type: Boolean,
      default: !1
    },
    width: {
      type: [String, Number],
      default: null
    },
    height: {
      type: [String, Number],
      default: null
    },
    originalStyle: {
      type: Boolean,
      default: !1
    },
    keepCursorInEnd: {
      type: Boolean,
      default: !1
    },
    merge: {
      type: Boolean,
      default: !1
    },
    name: {
      type: String,
      default: ""
    },
    marker: {
      type: Function,
      default: () => null
    },
    unseenLines: {
      type: Array,
      default: () => []
    }
  },
  emits: $e,
  setup(e, { expose: n, emit: r }) {
    var N, A;
    typeof Object.assign != "function" && Object.defineProperty(Object, "assign", {
      value(s) {
        if (s == null)
          throw new TypeError("Cannot convert undefined or null to object");
        const g = Object(s);
        for (let h = 1; h < arguments.length; h++) {
          const $ = arguments[h];
          if ($ != null)
            for (const E in $)
              Object.prototype.hasOwnProperty.call($, E) && (g[E] = $[E]);
        }
        return g;
      },
      writable: !0,
      configurable: !0
    });
    const t = e, o = r, a = v(null), l = v(""), m = q(V), u = v({
      ...O,
      ...t.globalOptions,
      ...t.options
    }), d = K(), i = t.name || ((A = (N = d == null ? void 0 : d.parent) == null ? void 0 : N.type) == null ? void 0 : A.name) || void 0, p = v(null), c = T(
      () => {
        var s;
        return t.merge ? (s = w(a)) == null ? void 0 : s.editor() : w(a);
      }
    ), { refresh: f, resize: k, destroy: y, containerHeight: B, reviseStyle: P } = be({
      props: t,
      cminstance: a,
      presetRef: p
    }), { listenerEvents: U } = _e({
      props: t,
      cminstance: a,
      emit: o,
      internalInstance: d,
      content: l
    }), D = () => {
      t.unseenLines !== void 0 && t.marker !== void 0 && t.unseenLines.forEach((s) => {
        var h, $;
        const g = (h = a.value) == null ? void 0 : h.lineInfo(s);
        ($ = a.value) == null || $.setGutterMarker(
          s,
          "breakpoints",
          g != null && g.gutterMarkers ? null : t.marker()
        );
      });
    }, W = (s) => {
      var h, $;
      const g = (h = a.value) == null ? void 0 : h.getValue();
      s !== g && (($ = a.value) == null || $.setValue(s), l.value = s, P()), D();
    }, J = () => {
      U(), D(), k(t.width, t.height), o("ready", a.value), x(
        [() => t.width, () => t.height],
        ([s, g]) => {
          k(s, g);
        },
        { deep: !0 }
      );
    }, G = () => {
      if (t.options.mode === "fclog" || t.options.mode === "log") {
        m.value = ye;
        return;
      }
      if (t.merge) {
        m.value = ue;
        return;
      }
      m.value = V;
    };
    return x(
      () => t.options,
      (s) => {
        var g;
        for (const h in t.options)
          (g = c.value) == null || g.setOption(
            h,
            w(s[h])
          );
      },
      { deep: !0 }
    ), x(
      () => t.value,
      (s) => {
        W(s);
      }
    ), x(() => t.merge, G, { immediate: !0 }), Q(() => {
      y();
    }), n({
      cminstance: a,
      resize: k,
      refresh: f,
      destroy: y
    }), (s, g) => (b(), S("div", {
      class: X(["codemirror-container", {
        merge: s.$props.merge,
        bordered: s.$props.border || s.$props.merge && !t.originalStyle,
        "width-auto": !s.$props.width || s.$props.width == "100%",
        "height-auto": !s.$props.height || s.$props.height == "100%",
        "original-style": t.originalStyle
      }]),
      style: Y({
        height: w(B) + "px"
      })
    }, [
      (b(), ee(te(m.value), ne({
        ref_key: "presetRef",
        ref: p,
        cminstance: a.value,
        "onUpdate:cminstance": g[0] || (g[0] = (h) => a.value = h),
        style: { height: "100%" }
      }, {
        ...s.$props,
        ...s.$attrs,
        options: u.value,
        name: w(i),
        content: l.value
      }, { onReady: J }), null, 16, ["cminstance"]))
    ], 6));
  }
});
const z = (e, n) => (n && n.options && (F.props.globalOptions.default = () => n.options), e.component((n == null ? void 0 : n.componentName) || "Codemirror", F), e), Ae = window.CodeMirror || _, Ve = z, Fe = z;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.codemirror-container {
  position: relative;
  display: inline-block;
  height: 100%;
  width: fit-content;
  font-size: 12px;
  overflow: hidden;
}
.codemirror-container.bordered {
  border-radius: 4px;
  border: 1px solid #dddddd;
}
.codemirror-container.width-auto {
  width: 100%;
}
.codemirror-container.height-auto {
  height: 100%;
}
.codemirror-container.height-auto .CodeMirror,
.codemirror-container.height-auto .cm-s-default {
  height: 100% !important;
}
.codemirror-container .editor_custom_link {
  cursor: pointer;
  color: #1474f1;
  text-decoration: underline;
}
.codemirror-container .editor_custom_link:hover {
  color: #04b4fa;
}
.codemirror-container:not(.original-style) .CodeMirror-lines .CodeMirror-placeholder.CodeMirror-line-like {
  color: #666;
}
.codemirror-container:not(.original-style) .CodeMirror,
.codemirror-container:not(.original-style) .CodeMirror-merge-pane {
  height: 100%;
  font-family: consolas !important;
}
.codemirror-container:not(.original-style) .CodeMirror-merge,
.codemirror-container:not(.original-style) .CodeMirror-merge-right .CodeMirror {
  height: 100%;
  border: none !important;
}
.codemirror-container:not(.original-style) .c-editor--log__error {
  color: #bb0606;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__info {
  color: #333333;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__warning {
  color: #ee9900;
}
.codemirror-container:not(.original-style) .c-editor--log__success {
  color: #669600;
}
.codemirror-container:not(.original-style) .cm-header,
.codemirror-container:not(.original-style) .cm-strong {
  font-weight: bold;
}
`);
export {
  Ae as CodeMirror,
  Ve as GlobalCmComponent,
  Fe as InstallCodemirro,
  F as VueCodemirror,
  Te as createLinkMark,
  De as createLog,
  Ie as createLogMark,
  Ne as createTitle,
  F as default,
  me as getLinkMarks,
  pe as getLocalTime,
  ge as getLogMark,
  de as logErrorType
};
